#####################################################-*- makefile -*-##
# CERT SiLK Analysis Suite Global Makefile
# $SiLK: /scripts/build/recurse.mk,v 1.1 2005/06/27 16:37:05 thomasm Exp $
#######################################################################

# Protect against typos that create empty list of objects and invoke
# infinite recursion
ifeq ($(strip $(WITHDEPS_OBJ)),)
$(error No objects given for target--check for typos in your makefile)
endif


#######################################################################
# Get common variables
#######################################################################

SHELL = /bin/sh

include $(BUILDROOT)/scripts/build/skconfig.mk
include $(SUITEROOT)/scripts/build/target.mk


LDFLAGS_COMMON=$(WITHDEP_LDFLAGS) $(LDFLAGS_LOCAL) $(STDLIBS)


#######################################################################
# Compilation
#######################################################################

DEPLIBS_FLAGS=$(DEPLIBS_DIRS) $(patsubst lib%.a,-l%,$(notdir $(WITHDEPS_LIB)))

# Dependent library recursive make rules

ifndef NO_CHECK_DEPLIBS
# we're using $(sort ...) here to remove duplicates
$(sort $(WITHDEPS_LIB)): %: always_rebuild
	@echo Checking whether $(@F) needs rebuilding
	$(MAKE) -C $(dir $(@D)) libraries-$(APP_RELEASE)
endif

# Include automatically generated dependency rules
-include $(addsuffix .d, $(basename $(WITHDEPS_OBJ)))

# User application linking rules
$(APPLS_LOCAL_ALL): $(WITHDEPS_OBJ) $(WITHDEPS_LIB)
	@echo "Final link for application $@"
	$(CC) -o $@ $(WITHDEPS_OBJ) $(LINK_FLAGS_$(APP_RELEASE)) $(DEPLIBS_FLAGS) $(LDFLAGS_COMMON)

# Testing application linking rules
$(TAPPS_LOCAL_ALL): $(WITHDEPS_OBJ) $(WITHDEPS_LIB)
	@echo "Final link for testing application $@"
	$(CC) -o $@ $(WITHDEPS_OBJ) $(LINK_FLAGS_$(APP_RELEASE)) $(DEPLIBS_FLAGS) $(LDFLAGS_COMMON)

# Library linking rules
$(LIBRS_LOCAL_ALL): $(WITHDEPS_OBJ)
	@echo "Creating library $@"
	-$(RM) -f $@
	$(AR) cr $@ $^
	$(RANLIB) $@

# Dynamic library rules
$(DYNAS_LOCAL_ALL): $(WITHDEPS_OBJ) $(WITHDEPS_LIB)
	@echo "Final link for shared object $@"
	$(SHLIB_LD) -o $@ $(SHLIB_LDFLAGS) $(WITHDEPS_OBJ) $(DEPLIBS_FLAGS) $(LDFLAGS_COMMON) $(SHLIB_LIBS)
