
/*-------------------------------------------------------------------------
 *  profile.h : definitions for routines to make profiling on the nodes
 *
 *  Copyright (C) 2004 by Accelerated Servers,
 *  			  Todd K McAnally <todd@acceleratedservers.com>
 *  			  Charles Galpin  <charles@acceleratedservers.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $SiLK: profile.h,v 1.2 2004/05/12 17:07:14 thomasm Exp $
 *-----------------------------------------------------------------------*/

#ifndef __PROFILE__H
#define __PROFILE__H

#include <sys/times.h>

struct profile {
	char name[30];
	unsigned long int times_called;
	clock_t cur_starttime;
	clock_t cur_stoptime;
	struct tms cur_starttms;
	struct tms cur_stoptms;
	unsigned long long int total_time;
	struct tms total_tms;
	clock_t largest;
	clock_t smallest;

};

extern void init_profile(struct profile *prof, char * name);
extern void start_profile (struct profile *prof);
extern void stop_profile (struct profile *prof); 
extern void print_profile(FILE *out, struct profile *prof);

#endif
